﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using DlhSoft.Windows.Data;

namespace LoadChartViewCustomDataBindingSample
{
    // Represents a custom task item.
    // It is recommended to implement INotifyPropertyChanged if you plan to change the item values dynamically.
    class CustomTaskItem
    {
        // The display name of the task.
        public string DisplayName { get; set; }
        // Indentation of the task.
        public int IndentLevel { get; set; }
        // The schedule of the task.
        public Schedule TaskSchedule { get; set; }
        // The start date and time of the task.
        public DateTime StartDate { get; set; }
        // The effort of the task.
        public TimeSpan WorkEffort { get; set; }
        // The duration of the task.
        public TimeSpan WorkDuration { get; set; }
        // The finish date and time of the task.
        public DateTime FinishDate { get; set; }
        // The milestone indicator of the task.
        public bool IsMilestoneTask { get; set; }
        // The completed effort of the task.
        public TimeSpan CompletedWorkEffort { get; set; }
        // The completion of the task.
        public double PercentCompleted { get; set; }
        // The completion indicator of the task.
        public bool IsWorkCompleted { get; set; }
        // The assignments of the task.
        public string AssignedResources { get; set; }
        // The index of the task.
        public string TaskIndex { get; set; }
        // The predecessors of the task.
        public string PredecessorTaskIndexes { get; set; }
        // The cost of the task.
        public double TaskCost { get; set; }

        // Define any other custom properties.
        public string Description { get; set; }
    }
}
